package models

import (
	"lapp_-wy/db"
	"lapp_-wy/utils"
	"time"
)

type WfApprovalrequestDetail struct {
	Detailid          int     `json:"detailid" xorm:"pk INT(11) autoincr"`
	Approvalrequestid int     `json:"approvalrequestid" xorm:"INT(11)"`
	Cid               int     `json:"cid" xorm:"default NULL INT(11)"`
	Approvalmodelid   int     `json:"approvalmodelid" xorm:"default NULL INT(11)"`
	Requester         string  `json:"requester" xorm:"default 'NULL' VARCHAR(20)"`
	Agentman          string  `json:"agentman" xorm:"default 'NULL' VARCHAR(20)"`
	Subject           string  `json:"subject" xorm:"default 'NULL' VARCHAR(255)"`
	Requesttime       string  `json:"requesttime" xorm:"default 'NULL' VARCHAR(14)"`
	Itemname          string  `json:"itemname" xorm:"default 'NULL' VARCHAR(100)"`
	Specmodel         string  `json:"specmodel" xorm:"default 'NULL' VARCHAR(100)"`
	Money             float64 `json:"money" xorm:"default '0.0' DECIMAL(10,2)"`
	Requestinfo       string  `json:"requestinfo" xorm:"default 'NULL' VARCHAR(100)"`
	Approvaltype      string  `json:"approvaltype" xorm:"default 'NULL' VARCHAR(20)"`
	Requestobjid      string  `json:"requestobjid" xorm:"default 'NULL' VARCHAR(40)"`
	Picpath           string  `json:"picpath" xorm:"default 'NULL' VARCHAR(255)"`
	Lastmodif         string  `json:"lastmodif" xorm:"default 'NULL' VARCHAR(14)"`
	Lastuser          string  `json:"lastuser" xorm:"default 'NULL' VARCHAR(20)"`
	Credatuz          string  `json:"credatuz" xorm:"default 'NULL' VARCHAR(14)"`
	Reqtype           int     `json:"reqtype" xorm:"INT(2)"`
	Purpose           string  `json:"purpose" xorm:"default 'NULL' VARCHAR(255)"`
	Qty               int     `json:"qty" xorm:"default '0' INT(8)"`
}

func (t *WfApprovalrequestDetail) TableName() string {
	return "wf_approvalrequest_detail"
}

//增
func (t *WfApprovalrequestDetail) Add() error {
	engine := db.MasterEngine()
	session := engine.NewSession()
	defer session.Close()
	// add Begin() before any action
	err := session.Begin()
	if err != nil {
		session.Rollback()
		return err
	}
	u := &WfApprovalrequestDetail{
		Approvalrequestid: t.Approvalrequestid,
		Approvalmodelid:   t.Approvalmodelid,
		Requester:         t.Requester,
		Requesttime:       utils.TimeFormat(time.Now(), "yyyy-MM-dd HH:mm:ss"),
		Agentman:          t.Agentman,
		Subject:           t.Subject,
		Itemname:          t.Itemname,
		Specmodel:         t.Specmodel,
		Cid:               t.Cid,
		Picpath:           t.Picpath,
		Money:             t.Money,
		Requestinfo:       t.Requestinfo,
		Approvaltype:      t.Approvaltype,
		Requestobjid:      t.Requestobjid,
		Lastmodif:         utils.TimeFormat(time.Now(), "yyyy-MM-dd HH:mm:ss"),
		Lastuser:          t.Lastuser,
		Credatuz:          utils.TimeFormat(time.Now(), "yyyy-MM-dd HH:mm:ss"),
		Reqtype:           t.Reqtype,
		Purpose:           t.Purpose,
		Qty:               t.Qty,
	}
	_, err = session.Table("wf_approvalrequest_detail").Insert(u)
	if err != nil {
		session.Rollback()
		return err
	}
	err = session.Commit()
	if err != nil {
		return err
	}
	return nil
}

//删
func (t *WfApprovalrequestDetail) Del() error {
	e := db.MasterEngine()
	_, err := e.Table("wf_approvalrequest_detail").ID(t.Detailid).Delete(&WfApprovalrequestDetail{})
	if err != nil {
		return err
	}
	return nil
}

//改
func (t *WfApprovalrequestDetail) Update() error {
	e := db.MasterEngine()
	_, err := e.Table("wf_approvalrequest_detail").ID(t.Detailid).Update(t)
	if err != nil {
		return err
	}
	return err
}

//查
func (t *WfApprovalrequestDetail) SelectOne() (WfApprovalrequestDetail, error) {
	e := db.MasterEngine()
	var data WfApprovalrequestDetail
	_, err := e.Table("wf_approvalrequest_detail").ID(t.Detailid).Get(&data)
	if err != nil {
		return data, err
	}
	return data, nil
}
